<template>
  <div class="common-container">

    <div class="row">
      <div class="col-xs-8">
        <div class="small-title">Резюме</div>
        <div class="row mb2">
          <div class="col-xs-12">
            <ob-input
              label="Краткое название тендера"
              :required="isEditable"
              :readonly="!isEditable"
              v-model="formData.title"
              data-qa="title"
            />
          </div>
        </div>
        <div class="row mb2">
          <div class="col-xs-12">
            <ob-textarea
              class="description-textarea"
              label="Описание тендера"
              :required="isEditable"
              :readonly="!isEditable"
              v-model="formData.description"
              data-qa="description"
            />
          </div>
        </div>
        <div class="row mb2">
          <div class="col-xs-12">
            <ob-input
              label="Контактное лицо организатора"
              :required="isEditable"
              :readonly="!isEditable"
              v-model="formData.contacts"
              data-qa="contacts"
            />
          </div>
        </div>
        <div class="row">
          <div class="col-xs-4">
            <ob-datepicker
              ref="targetFinishDt"
              v-model="formData.targetFinishDt"
              @open="setDateState('targetFinishDt')"
              @focus="setDateState('targetFinishDt')"
              :date-validation-message="getValidationMessage()"
              :is-valid-date="isDateValid('targetFinishDt')"
              :since-to="disabledDate"
              :readonly="!isEditable"
              :required="isEditable"
              :is-time="true"
              label="Завершение сбора предложений"
              data-qa="targetFinishDt"
            />
          </div>
          <div class="col-xs-4">
            <ob-datepicker
              ref="summarizingDt"
              v-model="formData.summarizingDt"
              @open="setDateState('summarizingDt')"
              @focus="setDateState('summarizingDt')"
              :date-validation-message="getValidationMessage('summarizingDt')"
              :is-valid-date="isSummarizingDtValid"
              :since-to="disabledDate"
              :readonly="!isEditable"
              :required="isEditable"
              :is-time="true"
              label="Окончание подведения итогов"
              data-qa="summarizingDt"
            />
          </div>
        </div>
        <div class="row mb2 timezone-text">Время указывается по часовому поясу Москвы UTC+3</div>

        <div v-if="isRFQ">
          <div class="small-title">Период действия договора</div>
          <div class="row">
            <div class="col-xs-4">
              <ob-datepicker
                ref="startContractDt"
                v-model="formData.startContractDt"
                @open="setDateState('startContractDt')"
                @focus="setDateState('startContractDt')"
                :date-validation-message="getValidationMessage()"
                :is-valid-date="isDateValid('startContractDt')"
                :since-to="disabledDate"
                :readonly="!isEditable"
                :required="isEditable"
                :is-time="true"
                label="Начало исполнения договора"
                data-qa="startContractDt"
              />
            </div>
            <div class="col-xs-4">
              <ob-datepicker
                ref="endContractDt"
                v-model="formData.endContractDt"
                @open="setDateState('endContractDt')"
                @focus="setDateState('endContractDt')"
                :date-validation-message="getValidationMessage('endContractDt')"
                :is-valid-date="isEndContractDtValid"
                :since-to="disabledDate"
                :readonly="!isEditable"
                :required="isEditable"
                :is-time="true"
                label="Окончание исполнения договора"
                data-qa="endContractDt"
              />
            </div>
          </div>
          <div class="row mb2 timezone-text">Время указывается по часовому поясу Москвы UTC+3</div>
          <div class="small-title">Требования к подаче предложений</div>
          <div class="row mb2">
            <div class="col-xs-8">
              <ob-select
                label="Тип перевозки"
                :isStandart="true"
                :remote-opt="{
                  method: api.tenders.getTypesOfCarriage
                }"
                :required="isEditable"
                :disabled="!isEditable"
                v-model="formData.transportationTypeUuid"
                data-qa="transportationType"
                @selected="onDropdownChanged('transportationTypeTitle', $event)"
              />
            </div>
          </div>
          <div class="row mb2">
            <div class="col-xs-4">
              <ob-select
                label="Валюта для указания цен"
                :required="isEditable"
                valueExp="data"
                :disabled="true"
                :items="[{ title: 'Рубли', data: 'RUR'}]"
                data-qa="currency"
              />
            </div>
            <div class="col-xs-4">
              <ob-select
                label="Указывать цены"
                :required="isEditable"
                :remote-opt="{
                  method: api.tenders.getTaxTreatment
                }"
                :disabled="!isEditable"
                v-model="formData.vatUuid"
                data-qa="vat"
                @selected="onDropdownChanged('vatTitle', $event)"
              />
            </div>
          </div>

        </div>

      </div>

      <div
        v-if="isStatisticsShown"
        class="col-xs-4"
      >
        <TenderStatistics :tender="tender" />
      </div>
    </div>
    <div class="small-title">Инструкция и дополнительные файлы к анкете</div>
    <div class="row">
      <div class="col-xs-8">
        <div class="row">
          <div class="col-xs-12">
            <ob-textarea
              label="Дополнительная информация"
              :readonly="!isEditable"
              v-model="formData.instruction"
              data-qa="instruction"
            />
          </div>
        </div>
      </div>
      <div class="col-xs-4">
        <ob-uploader
          v-if="isEditable"
          icon="excel"
          :multiple="true"
          :isDetailEmit="true"
          data-qa="uploader"
          @change="onChangeFiles($event)"
        />

        <div class="existing-files">
          <div
            class="existing-file"
            v-for="file in files"
            :key="file.uuid"
            data-qa="download"
            @click="downloadFile(file)"
          >
            <span class="existing-file-text">{{ file.name }}</span>
            <i v-if="isEditable" data-qa="deleteFile" @click.stop="onDeleteFile(file.uuid)" class="icon close existing-file-icon"></i>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
  import api from "@/api";
  import { mapGetters, mapActions } from 'vuex';
  import DatesValidationMixin from "./../../../mixins/datesValidation";
  import TenderStatistics from "./components/TenderStatistics";

  import ObInput from 'common-components/src/obComponents/obInput';
  import ObTextarea from 'common-components/src/obComponents/obTextarea';
  import ObUploader from 'common-components/src/obComponents/obUploader';
  import ObSelect from 'common-components/src/obComponents/obSelect';

  export default {
    name: "tender-tab-buyer-common",
    mixins: [
      DatesValidationMixin
    ],
    components: {
      ObInput,
      ObTextarea,
      ObUploader,
      ObSelect,
      TenderStatistics
    },
    props: {
      tender: {
        type: Object,
        required: true
      }
    },
    watch: {
      formData: {
        deep: true,
        handler: function(val) {
          if (this.tender.status === 'DRAFT') {
            if (this.isInitialChange) {
              this.isInitialChange = false;
            } else {
              this.setFormData(val);
              this.wasChangedAfterInitial = true;
              clearTimeout(this.debounceTimeout);
              this.debounceTimeout = setTimeout(() => this.updateTenderInfo(), 1500);
            }
          }
        }
      },
      isAllDatesValid: {
        handler (status) {
          this.setDatesValidStatus(status)
        },
        immediate: true
      }
    },
    computed: {
      ...mapGetters({
        tenderFormData: 'tenders/tenderFormData',
        tenderFormDataChanged: 'tenders/tenderFormDataChanged',
        isEditable: 'tenders/isEditable',
        currentRole: 'tenders/currentRole'
      }),

      isRFQ: ({ tender }) => tender.type === 'RFQ',
      isStatisticsShown: ({ currentRole, tender }) => currentRole === 'client' && tender.status !== 'DRAFT'
    },
    data() {
      return {
        api,
        isInitialChange: true,
        wasChangedAfterInitial: false,
        debounceTimeout: 0,
        files: []
      }
    },
    created() {
      this.formData = {...this.tenderFormData};

      //fix for bug in obDatepicker
      if (this.formData.startContractDt === null) this.formData.startContractDt = undefined;
      if (this.formData.endContractDt === null) this.formData.endContractDt = undefined;

      this.files = this.formData.fileUuids.map(fileUuid => ({ uuid: fileUuid, name: '' }));
      this.getFiles();
    },
    beforeDestroy() {
      if (this.wasChangedAfterInitial && this.tenderFormDataChanged) this.updateTenderInfo();
    },
    methods: {
      ...mapActions({
        setFormData: 'tenders/setTenderFormData',
        updateTenderInfo: 'tenders/updateTenderInfo',
        setDatesValidStatus: 'tenders/setDatesValidStatus'
      }),

      getFiles() {
        if (this.files.length) {
          this.files.map(async file => {
            const response = await api.files.getFile(file.uuid);
            file.name = response.name;
            file.data = response.data;
          })
        }
      },

      downloadFile(file) {
        const fileName = file.name;
        const url = window.URL.createObjectURL(new Blob([file.data]));
        const link = document.createElement('a');
        link.href = url;
        link.setAttribute('download', fileName);
        document.body.appendChild(link);
        link.click();
        document.body.removeChild(link);
      },

      onDeleteFile(uuid) {
        this.files = this.files.filter(file => file.uuid !== uuid);
        this.formData.fileUuids = this.formData.fileUuids.filter(fileUuid => fileUuid !== uuid);
      },

      async onChangeFiles(e) {

        if (e.added) {
          const uploadRequest = ({ uuid, file }) => {
            return new Promise((resolve, reject) => {
              api.files.postFile({ uuid, file }).then(() => {
                resolve();
              }).catch(e => {
                console.log(e);
                reject(e);
              })
            });
          }
          const delayedLog = async (item) => {
            await uploadRequest(item);
          }
          const uploadFiles = async (array) => {
            const promises = array.map(delayedLog);
            await Promise.all(promises);
          }

          await uploadFiles(e.added);
          e.added.forEach(file => this.formData.fileUuids.push(file.uuid));
        }

        if (e.deleted) {
          this.formData.fileUuids = this.formData.fileUuids.filter(fileUuid => fileUuid !== e.deleted);
        }
      },
      onDropdownChanged (key, value) {
        // For example, <ObSelect> for 'transportationType' field will change
        // only 'transportationTypeUuid' in v-model, but needed to change 'transportationTypeTitle'
        // to show it in tender header for users
        this.formData[key] = value.title
      }
    }
  };
</script>

<style lang="scss" scoped>
  @import "~common-components/src/assets/style/ob-style";
  @import "~common-components/src/static/css/mixins";

  .timezone-text {
    font-family: "Roboto", sans-serif;
    font-size: 12px;
    line-height: 12px;
    letter-spacing: 0.4px;
    color: $gray-slate;
    padding: 0 10px;
    margin-top: 10px;
  }

  .common-container {
    padding: 20px;

    &::v-deep {
      .ob-uploader-body {
        height: 72px;
      }

      .description-textarea textarea {
        min-height: 144px;
      }
    }
  }

  .small-title {
    @include font-mixin(16px, 20px, 700, $tendersPage-buyer_common_small_title, 0.4px);
    margin-bottom: 18px;
  }

  .mb2 {
    margin-bottom: 30px;
  }

  .existing-files {
    display: flex;
    flex-wrap: wrap;
  }

  .existing-file {
    display: flex;
    align-items: center;
    justify-content: space-between;
    padding: 5px 12px;
    border-radius: 10px;
    background: $blue-250;
    margin: 10px 10px 0 0;
    min-height: 28px;
    cursor: pointer;
  }

  .existing-file-text {
    @include font-mixin(14px, 18px, 400, $color-text-base);

    text-align: center;
    position: relative;
    margin-right: 4px;
  }

  .existing-file-icon {
    font-size: 12px;
    font-weight: bold;
    cursor: pointer;
    color: $gray-slate;
  }
</style>
